Open CASCADE Technology: HLRBRep_Algo Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
HLRBRep_Algo Class Reference

Inherited from InternalAlgo to provide methods with Shape from TopoDS. A framework to compute a shape as seen in a projection plane. This is done by calculating the visible and the hidden parts of the shape. HLRBRep_Algo works with three types of entity: More...

`#include <HLRBRep_Algo.hxx>`

Inheritance diagram for HLRBRep_Algo:
[legend]

## Public Member Functions
| HLRBRep_Algo ()
| Constructs an empty framework for the calculation of visible and hidden lines of a shape in a projection. Use the function: More...
| HLRBRep_Algo (const Handle< HLRBRep_Algo > &A)
void | Add (const TopoDS_Shape &S, const Handle< MMgt_TShared > &SData, const Standard_Integer nbIso=0)
| add the Shape <S>. More...
void | Add (const TopoDS_Shape &S, const Standard_Integer nbIso=0)
| Adds the shape S to this framework, and specifies the number of isoparameters nbiso desired in visualizing S. You may add as many shapes as you wish. Use the function Add once for each shape. More...
Standard_Integer | Index (const TopoDS_Shape &S)
| return the index of the Shape <S> and return 0 if the Shape <S> is not found. More...
void | OutLinedShapeNullify ()
| nullify all the results of OutLiner from HLRTopoBRep. More...
Public Member Functions inherited from HLRBRep_InternalAlgo
| HLRBRep_InternalAlgo ()
| HLRBRep_InternalAlgo (const Handle< HLRBRep_InternalAlgo > &A)
void | Projector (const HLRAlgo_Projector &P)
| set the projector. More...
HLRAlgo_Projector & | Projector ()
| set the projector. More...
void | Update ()
| update the DataStructure. More...
void | Load (const Handle< HLRTopoBRep_OutLiner > &S, const Handle< MMgt_TShared > &SData, const Standard_Integer nbIso=0)
| add the shape <S>. More...
void | Load (const Handle< HLRTopoBRep_OutLiner > &S, const Standard_Integer nbIso=0)
| add the shape <S>. More...
Standard_Integer | Index (const Handle< HLRTopoBRep_OutLiner > &S) const
| return the index of the Shape <S> and return 0 if the Shape <S> is not found. More...
void | Remove (const Standard_Integer I)
| remove the Shape of Index . More...
void | ShapeData (const Standard_Integer I, const Handle< MMgt_TShared > &SData)
| Change the Shape Data of the Shape of index . More...
HLRBRep_SeqOfShapeBounds & | SeqOfShapeBounds ()
Standard_Integer | NbShapes () const
HLRBRep_ShapeBounds & | ShapeBounds (const Standard_Integer I)
void | InitEdgeStatus ()
| init the status of the selected edges depending of the back faces of a closed shell. More...
void | Select ()
| select all the DataStructure. More...
void | Select (const Standard_Integer I)
| select only the Shape of index . More...
void | SelectEdge (const Standard_Integer I)
| select only the edges of the Shape <S>. More...
void | SelectFace (const Standard_Integer I)
| select only the faces of the Shape <S>. More...
void | ShowAll ()
| set to visible all the edges. More...
void | ShowAll (const Standard_Integer I)
| set to visible all the edges of the Shape <S>. More...
void | HideAll ()
| set to hide all the edges. More...
void | HideAll (const Standard_Integer I)
| set to hide all the edges of the Shape <S>. More...
void | PartialHide ()
| own hiding of all the shapes of the DataStructure without hiding by each other. More...
void | Hide ()
| hide all the DataStructure. More...
void | Hide (const Standard_Integer I)
| hide the Shape <S> by itself. More...
void | Hide (const Standard_Integer I, const Standard_Integer J)
| hide the Shape <S1> by the shape <S2>. More...
void | Debug (const Standard_Boolean deb)
Standard_Boolean | Debug () const
Handle< HLRBRep_Data > | DataStructure () const
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Detailed Description

Inherited from InternalAlgo to provide methods with Shape from TopoDS. A framework to compute a shape as seen in a projection plane. This is done by calculating the visible and the hidden parts of the shape. HLRBRep_Algo works with three types of entity:

- shapes to be visualized
- edges in these shapes (these edges are the basic entities which will be visualized or hidden), and
- faces in these shapes which hide the edges. HLRBRep_Algo is based on the principle of comparing each edge of the shape to be visualized with each of its faces, and calculating the visible and the hidden parts of each edge. For a given projection, HLRBRep_Algo calculates a set of lines characteristic of the object being represented. It is also used in conjunction with the HLRBRep_HLRToShape extraction utilities, which reconstruct a new, simplified shape from a selection of calculation results. This new shape is made up of edges, which represent the shape visualized in the projection. HLRBRep_Algo takes the shape itself into account whereas HLRBRep_PolyAlgo works with a polyhedral simplification of the shape. When you use HLRBRep_Algo, you obtain an exact result, whereas, when you use HLRBRep_PolyAlgo, you reduce computation time but obtain polygonal segments. In the case of complicated shapes, HLRBRep_Algo may be time-consuming. An HLRBRep_Algo object provides a framework for:
- defining the point of view
- identifying the shape or shapes to be visualized
- calculating the outlines
- calculating the visible and hidden lines of the shape. Warning
- Superimposed lines are not eliminated by this algorithm.
- There must be no unfinished objects inside the shape you wish to visualize.
- Points are not treated.
- Note that this is not the sort of algorithm used in generating shading, which calculates the visible and hidden parts of each face in a shape to be visualized by comparing each face in the shape with every other face in the same shape.

## Constructor & Destructor Documentation

HLRBRep_Algo::HLRBRep_Algo | ( |  | ) |

Constructs an empty framework for the calculation of visible and hidden lines of a shape in a projection. Use the function:

- Projector to define the point of view
- Add to select the shape or shapes to be visualized
- Update to compute the outlines of the shape, and
- Hide to compute the visible and hidden lines of the shape.

HLRBRep_Algo::HLRBRep_Algo | ( | const Handle< HLRBRep_Algo > & | A | ) |

## Member Function Documentation

void HLRBRep_Algo::Add | ( | const TopoDS_Shape & | S,
|  | const Handle< MMgt_TShared > & | SData,
|  | const Standard_Integer | nbIso = `0`
| ) |  |

add the Shape <S>.

void HLRBRep_Algo::Add | ( | const TopoDS_Shape & | S,
|  | const Standard_Integer | nbIso = `0`
| ) |  |

Adds the shape S to this framework, and specifies the number of isoparameters nbiso desired in visualizing S. You may add as many shapes as you wish. Use the function Add once for each shape.

Standard_Integer HLRBRep_Algo::Index | ( | const TopoDS_Shape & | S | ) |

return the index of the Shape <S> and return 0 if the Shape <S> is not found.

void HLRBRep_Algo::OutLinedShapeNullify | ( |  | ) |

nullify all the results of OutLiner from HLRTopoBRep.

The documentation for this class was generated from the following file:

- HLRBRep_Algo.hxx